if (!window.gcmobilesdk) {
    window.gcmobilesdk = {
        version: '1.0.2.1',
        processingQueue: false,
        gcipResults: [],
        gcipCallback: null,
        cameraVisible: false,
        updateDimensionCallback: null,
        jpegCallbacks: [],
        gciCallbacks: [],
        videoSize: { width: 0, height: 0} ,
        cameraList: [],
        challenge: "", //Filler need to replace with real,
        needsSDKAudio: true,
        recordGCIPResults: function(results) {
            //console.log("GCIP Results:", results);
            try {
                var res = JSON.parse(results || '');
                if (this.gcipCallback) {
                    this.gcipCallback(res);
                } else {
                    this.gcipResults.push(res);
                }
            } catch (e) { }
        },
        getChallenge: function() {
            return this.challenge;
        },
        setChallengeResponse: function(r) {
            this.command('setChallengeResponse', r);
        },
        notifyCameraVisible: function(s) {
            this.cameraVisible = s;
            if (this.cameraVisibleCallback) {
                this.cameraVisibleCallback(s);
            }
        },
        updateDimensions: function(w,h) {
            this.videoSize.width = w;
            this.videoSize.height = h;
            if (this.updateDimensionCallback) {
                this.updateDimensionCallback(w,h);
            }
        },
        setFormDetected: function(detected) {
            if (this.formDetectedCallback) {
                this.formDetectedCallback(detected);
            }
        },
        command: function() {
            var args = Array.prototype.slice.call(arguments);
            //console.log(JSON.stringify(args));
            window.JsInterface.command(args);
        },
        commands: ['setCamera', 'open', 'browse', 'download', 'review', 'getGciImage', 'getJpegImage', 'exit', 'stopScanning', 'startScanning', 'show', 'hide'],
        supportsCommand: function(cmd) {
            return this.commands.indexOf(cmd) != -1;
        },
        exitApp: function() {
            this.command('exit');
        },
        download: function(url) {
            this.command('download', url);
        },
        browse: function(url, target) {
            window.gcmobilesdk.command("browse", url, target);
        },
        showOnDiv: function() {
            var self = this;
            this.visible = true;
            this.command('show');
            this.command('startScanning');
            return false;
        },
        hide: function() {
            this.visible = false;
            this.command('stopScanning');
            this.command('hide');
            clearInterval(this.positionInterval);
        },
        getJpegImage: function(cb) {
            if (!this.jpegCallbacks) { this.jpegCallbacks = []; }
            this.jpegCallbacks.push(cb);
            this.command('getJpegImage');
        },
        setJpegData: function(data) {
            cb = this.jpegCallbacks.shift();
            if (cb) { cb(data); }
        },
        getCurrentImage: function(cb) {
            if (!this.gciCallbacks) { this.gciCallbacks = []; }
            this.gciCallbacks.push(cb);
            this.command('getGciImage');
        },
        setGciData: function(data) {
            cb = this.gciCallbacks.shift();
            if (cb) { cb(data); }
        },
        playSound: function() {
            if( window.JsInterface && window.JsInterface.playAudio){
                window.JsInterface.playAudio();
            }
        },
        startup: function(chall, camera_list) {
            var self = this, pid = -1, timeout = 200;
            self.challenge = window.atob(chall);
            self.cameraList = camera_list;
            function waitForStartup() {
                if (window.gcmobilesdk_loadCallback) {
                    window.gcmobilesdk_loadCallback();
                    clearInterval(pid);
                    document.body.style.backgroundColor = 'transparent';
                } else if (--timeout <= 0) { clearInterval(pid); }
            }
            pid = setInterval(waitForStartup, 50);
            //console.log("HELLO WORLD ====================*===================== " + self.challenge);
            //console.log("HELLO WORLD 2====================*===================== " + self.cameraList);
        }
    };
    window.open = function(url, target) {
        window.gcmobilesdk.browse(url, target);
    };
}

//window.gcmobilesdk.startup(); called when page loads

