;(function (win) {
  var doc   = win.document;
  var docEl = win.document.documentElement;
  var tid, dpr, scale;

  var devicePixelRatio = win.devicePixelRatio;

  if (devicePixelRatio >= 3) {
    dpr = 3;
  }
  else if (devicePixelRatio >= 2) {
    dpr = 2;
  }
  else {
    dpr = 1;
  }

  docEl.setAttribute('data-dpr', dpr);
  scale = 1 / dpr;

  var metaEl = doc.createElement('meta');
  metaEl.setAttribute('name', 'viewport');

  var pathname = location.pathname.replace(/\/$/, '');
  var pageFile = pathname.substr(pathname.lastIndexOf('/') + 1).toLowerCase();

  //differentiate 'scan.html' vs 'index.html'

  if (pageFile.indexOf('scan') >= 0)
    metaEl.setAttribute('content', 'initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0, user-scalable=no');
  else
    metaEl.setAttribute('content', 'initial-scale=' + scale + ', maximum-scale=' + scale + ', minimum-scale=' + scale + ', user-scalable=no');

  docEl.firstElementChild.appendChild(metaEl);

  function refreshRem () {
    var width = docEl.clientWidth;
    if (width / dpr > 540) width = 540 * dpr;

    var rem = width / 10;
    docEl.style.fontSize = rem + 'px';
  };

  win.addEventListener('resize', function () {
    clearTimeout(tid);
    tid = setTimeout(refreshRem, 300);
  }, false);

  win.addEventListener('pageshow', function (e) {
    if (e.persisted) {
      clearTimeout(tid);
      tid = setTimeout(refreshRem, 300);
    }
  }, false);

  if (doc.readyState === 'complete') {
    doc.body.style.fontSize = 12 * dpr + 'px';
  } else {
    doc.addEventListener('DOMContentLoaded', function () {
      doc.body.style.fontSize = 12 * dpr + 'px';
    }, false);
  }

  refreshRem();
})(window);
